# Copyright (C) 2024, UChicago Argonne, LLC
# Licensed under the 3-clause BSD license.  See accompanying LICENSE.txt file
# in the top-level directory.

from enum import Enum, auto


class PBS_BATCH(Enum):
    PBS_BATCH_Connect = 0
    PBS_BATCH_QueueJob = 1
    PBS_BATCH_PostQueueJob = 2
    PBS_BATCH_jobscript = 3
    PBS_BATCH_RdytoCommit = 4
    PBS_BATCH_Commit = 5
    PBS_BATCH_DeleteJob = 6
    PBS_BATCH_HoldJob = 7
    PBS_BATCH_LocateJob = 8
    PBS_BATCH_Manager = 9
    PBS_BATCH_MessJob = 10
    PBS_BATCH_ModifyJob = 11
    PBS_BATCH_MoveJob = 12
    PBS_BATCH_ReleaseJob = 13
    PBS_BATCH_Rerun = 14
    PBS_BATCH_RunJob = 15
    PBS_BATCH_SelectJobs = 16
    PBS_BATCH_Shutdown = 17
    PBS_BATCH_SignalJob = 18
    PBS_BATCH_StatusJob = 19
    PBS_BATCH_StatusQue = 20
    PBS_BATCH_StatusSvr = 21
    PBS_BATCH_TrackJob = 22
    PBS_BATCH_AsyrunJob = 23
    PBS_BATCH_Rescq = 24
    PBS_BATCH_ReserveResc = 25
    PBS_BATCH_ReleaseResc = 26
    PBS_BATCH_FailOver = 27
    PBS_BATCH_JobObit = 28
    PBS_BATCH_StageIn = 48
    PBS_BATCH_OrderJob = 50
    PBS_BATCH_SelStat = 51
    PBS_BATCH_RegistDep = 52
    PBS_BATCH_CopyFiles = 54
    PBS_BATCH_DelFiles = 55
    PBS_BATCH_MvJobFile = 57
    PBS_BATCH_StatusNode = 58
    PBS_BATCH_Disconnect = 59
    PBS_BATCH_JobCred = 62
    PBS_BATCH_CopyFiles_Cred = 63
    PBS_BATCH_DelFiles_Cred = 64
    PBS_BATCH_SubmitResv = 70
    PBS_BATCH_StatusResv = 71
    PBS_BATCH_DeleteResv = 72
    PBS_BATCH_BeginResv = 76
    PBS_BATCH_UserCred = 73
    PBS_BATCH_ConfirmResv = 75
    PBS_BATCH_DefSchReply = 80
    PBS_BATCH_StatusSched = 81
    PBS_BATCH_StatusRsc = 82
    PBS_BATCH_StatusHook = 83
    PBS_BATCH_PySpawn = 84
    PBS_BATCH_CopyHookFile = 85
    PBS_BATCH_DelHookFile = 86
    PBS_BATCH_HookPeriodic = 89
    PBS_BATCH_RelnodesJob = 90
    PBS_BATCH_ModifyResv = 91
    PBS_BATCH_ResvOccurEnd = 92
    PBS_BATCH_PreemptJobs = 93
    PBS_BATCH_Cred = 94
    PBS_BATCH_Authenticate = 95
    PBS_BATCH_ModifyJob_Async = 96
    PBS_BATCH_AsyrunJob_ack = 97
    PBS_BATCH_RegisterSched = 98
    PBS_BATCH_ModifyVnode = 99
    PBS_BATCH_DeleteJobList = 100


class PBS_SCHED(Enum):
    SCH_SCHEDULE_NULL = 0
    SCH_SCHEDULE_NEW = auto()
    SCH_SCHEDULE_TERM = auto()
    SCH_SCHEDULE_TIME = auto()
    SCH_SCHEDULE_RECYC = auto()
    SCH_SCHEDULE_CMD = auto()
    SCH_CONFIGURE = auto()
    SCH_QUIT = auto()
    SCH_RULESET = auto()
    SCH_SCHEDULE_FIRST = auto()
    SCH_SCHEDULE_JOBRESV = auto()
    SCH_SCHEDULE_AJOB = auto()
    SCH_SCHEDULE_STARTQ = auto()
    SCH_SCHEDULE_MVLOCAL = auto()
    SCH_SCHEDULE_ETE_ON = auto()
    SCH_SCHEDULE_RESV_RECONFIRM = auto()
    SCH_SCHEDULE_RESTART_CYCLE = auto()
    SCH_CMD_HIGH = auto()


class DIS_ERR(Enum):
    DIS_SUCCESS = 0
    DIS_OVERFLOW = 1
    DIS_HUGEVAL = 2
    DIS_BADSIGN = 3
    DIS_LEADZRO = 4
    DIS_NONDIGIT = 5
    DIS_NULLSTR = 6
    DIS_EOD = 7
    DIS_NOMALLOC = 8
    DIS_PROTO = 9
    DIS_NOCOMMIT = 10
    DIS_EOF = 11


class PBS_REPLY(Enum):
    PBSE_ = 15000
    PBSE_NONE = 0
    PBSE_UNKJOBID = 15001
    PBSE_NOATTR = 15002
    PBSE_ATTRRO = 15003
    PBSE_IVALREQ = 15004
    PBSE_UNKREQ = 15005
    PBSE_TOOMANY = 15006
    PBSE_PERM = 15007
    PBSE_BADHOST = 15008
    PBSE_JOBEXIST = 15009
    PBSE_SYSTEM = 15010
    PBSE_INTERNAL = 15011
    PBSE_REGROUTE = 15012
    PBSE_UNKSIG = 15013
    PBSE_BADATVAL = 15014
    PBSE_MODATRRUN = 15015
    PBSE_BADSTATE = 15016
    PBSE_UNKQUE = 15018
    PBSE_BADCRED = 15019
    PBSE_EXPIRED = 15020
    PBSE_QUNOENB = 15021
    PBSE_QACESS = 15022
    PBSE_BADUSER = 15023
    PBSE_HOPCOUNT = 15024
    PBSE_QUEEXIST = 15025
    PBSE_ATTRTYPE = 15026
    PBSE_OBJBUSY = 15027
    PBSE_QUENBIG = 15028
    PBSE_NOSUP = 15029
    PBSE_QUENOEN = 15030
    PBSE_PROTOCOL = 15031
    PBSE_BADATLST = 15032
    PBSE_NOCONNECTS = 15033
    PBSE_NOSERVER = 15034
    PBSE_UNKRESC = 15035
    PBSE_EXCQRESC = 15036
    PBSE_QUENODFLT = 15037
    PBSE_NORERUN = 15038
    PBSE_ROUTEREJ = 15039
    PBSE_ROUTEEXPD = 15040
    PBSE_MOMREJECT = 15041
    PBSE_BADSCRIPT = 15042
    PBSE_STAGEIN = 15043
    PBSE_RESCUNAV = 15044
    PBSE_BADGRP = 15045
    PBSE_MAXQUED = 15046
    PBSE_CKPBSY = 15047
    PBSE_EXLIMIT = 15048
    PBSE_BADACCT = 15049
    PBSE_ALRDYEXIT = 15050
    PBSE_NOCOPYFILE = 15051
    PBSE_CLEANEDOUT = 15052
    PBSE_NOSYNCMSTR = 15053
    PBSE_BADDEPEND = 15054
    PBSE_DUPLIST = 15055
    PBSE_DISPROTO = 15056
    PBSE_EXECTHERE = 15057
    PBSE_SISREJECT = 15058
    PBSE_SISCOMM = 15059
    PBSE_SVRDOWN = 15060
    PBSE_CKPSHORT = 15061
    PBSE_UNKNODE = 15062
    PBSE_UNKNODEATR = 15063
    PBSE_NONODES = 15064
    PBSE_NODENBIG = 15065
    PBSE_NODEEXIST = 15066
    PBSE_BADNDATVAL = 15067
    PBSE_MUTUALEX = 15068
    PBSE_GMODERR = 15069
    PBSE_NORELYMOM = 15070
    PBSE_NOTSNODE = 15071
    PBSE_RESV_NO_WALLTIME = 15075
    PBSE_JOBNOTRESV = 15076
    PBSE_TOOLATE = 15077
    PBSE_IRESVE = 15078
    PBSE_RESVEXIST = 15080
    PBSE_resvFail = 15081
    PBSE_genBatchReq = 15082
    PBSE_mgrBatchReq = 15083
    PBSE_UNKRESVID = 15084
    PBSE_delProgress = 15085
    PBSE_BADTSPEC = 15086
    PBSE_RESVMSG = 15087
    PBSE_NOTRESV = 15088
    PBSE_BADNODESPEC = 15089
    PBSE_LICENSEINV = 15091
    PBSE_RESVAUTH_H = 15092
    PBSE_RESVAUTH_G = 15093
    PBSE_RESVAUTH_U = 15094
    PBSE_R_UID = 15095
    PBSE_R_GID = 15096
    PBSE_IBMSPSWITCH = 15097
    PBSE_UNUSED2 = 15098
    PBSE_NOSCHEDULER = 15099
    PBSE_RESCNOTSTR = 15100
    PBSE_MaxArraySize = 15107
    PBSE_INVALSELECTRESC = 15108
    PBSE_INVALJOBRESC = 15109
    PBSE_INVALNODEPLACE = 15110
    PBSE_PLACENOSELECT = 15111
    PBSE_INDIRECTHOP = 15112
    PBSE_INDIRECTBT = 15113
    PBSE_NODESTALE = 15115
    PBSE_DUPRESC = 15116
    PBSE_CONNFULL = 15117
    PBSE_LICENSE_MIN_BADVAL = 15118
    PBSE_LICENSE_MAX_BADVAL = 15119
    PBSE_LICENSE_LINGER_BADVAL = 15120
    PBSE_UNUSED3 = 15121
    PBSE_UNUSED4 = 15122
    PBSE_BAD_FORMULA = 15123
    PBSE_BAD_FORMULA_KW = 15124
    PBSE_BAD_FORMULA_TYPE = 15125
    PBSE_BAD_RRULE_YEARLY = 15126
    PBSE_BAD_RRULE_MONTHLY = 15127
    PBSE_BAD_RRULE_WEEKLY = 15128
    PBSE_BAD_RRULE_DAILY = 15129
    PBSE_BAD_RRULE_HOURLY = 15130
    PBSE_BAD_RRULE_MINUTELY = 15131
    PBSE_BAD_RRULE_SECONDLY = 15132
    PBSE_BAD_RRULE_SYNTAX = 15133
    PBSE_BAD_RRULE_SYNTAX2 = 15134
    PBSE_BAD_ICAL_TZ = 15135
    PBSE_HOOKERROR = 15136
    PBSE_NEEDQUET = 15137
    PBSE_ETEERROR = 15138
    PBSE_HISTJOBID = 15139
    PBSE_JOBHISTNOTSET = 15140
    PBSE_MIXENTLIMS = 15141
    PBSE_ENTLIMCT = 15142
    PBSE_ENTLIMRESC = 15143
    PBSE_ATVALERANGE = 15144
    PBSE_PROV_HEADERROR = 15145
    PBSE_NODEPROV_NOACTION = 15146
    PBSE_NODEPROV = 15147
    PBSE_NODEPROV_NODEL = 15148
    PBSE_NODE_BAD_CURRENT_AOE = 15149
    PBSE_NOLOOPBACKIF = 15153
    PBSE_IVAL_AOECHUNK = 15155
    PBSE_JOBINRESV_CONFLICT = 15156
    PBSE_NORUNALTEREDJOB = 15157
    PBSE_HISTJOBDELETED = 15158
    PBSE_NOHISTARRAYSUBJOB = 15159
    PBSE_FORCE_QSUB_UPDATE = 15160
    PBSE_SAVE_ERR = 15161
    PBSE_MAX_NO_MINWT = 15162
    PBSE_MIN_GT_MAXWT = 15163
    PBSE_NOSTF_RESV = 15164
    PBSE_NOSTF_JOBARRAY = 15165
    PBSE_NOLIMIT_RESOURCE = 15166
    PBSE_MOM_INCOMPLETE_HOOK = 15167
    PBSE_MOM_REJECT_ROOT_SCRIPTS = 15168
    PBSE_HOOK_REJECT = 15169
    PBSE_HOOK_REJECT_RERUNJOB = 15170
    PBSE_HOOK_REJECT_DELETEJOB = 15171
    PBSE_IVAL_OBJ_NAME = 15172
    PBSE_JOBNBIG = 15173
    PBSE_RESCBUSY = 15174
    PBSE_JOBSCRIPTMAXSIZE = 15175
    PBSE_BADJOBSCRIPTMAXSIZE = 15176
    PBSE_WRONG_RESUME = 15177
    PBSE_RESV_NOT_EMPTY = 15178
    PBSE_STDG_RESV_OCCR_CONFLICT = 15179
    PBSE_SOFTWT_STF = 15180
    PBSE_RESV_FROM_RESVJOB = 15181
    PBSE_RESV_FROM_ARRJOB = 15182
    PBSE_SELECT_NOT_SUBSET = 15183
    PBSE_RMUNKNOWN = 15201
    PBSE_RMBADPARAM = 15202
    PBSE_RMNOPARAM = 15203
    PBSE_RMEXIST = 15204
    PBSE_RMSYSTEM = 15205
    PBSE_RMPART = 15206
    RM_ERR_UNKNOWN = 15201
    RM_ERR_BADPARAM = 15202
    RM_ERR_NOPARAM = 15203
    RM_ERR_EXIST = 15204
    RM_ERR_SYSTEM = 15205
    PBSE_TRYAGAIN = 15208
    PBSE_ALPSRELERR = 15209
    PBSE_JOB_MOVED = 15210
    PBSE_SCHEDEXIST = 15211
    PBSE_SCHED_NAME_BIG = 15212
    PBSE_UNKSCHED = 15213
    PBSE_SCHED_NO_DEL = 15214
    PBSE_SCHED_PRIV_EXIST = 15215
    PBSE_SCHED_LOG_EXIST = 15216
    PBSE_ROUTE_QUE_NO_PARTITION = 15217
    PBSE_CANNOT_SET_ROUTE_QUE = 15218
    PBSE_QUE_NOT_IN_PARTITION = 15219
    PBSE_PARTITION_NOT_IN_QUE = 15220
    PBSE_INVALID_PARTITION_QUE = 15221
    PBSE_ALPS_SWITCH_ERR = 15222
    PBSE_SCHED_OP_NOT_PERMITTED = 15223
    PBSE_SCHED_PARTITION_ALREADY_EXISTS = 15224
    PBSE_INVALID_MAX_JOB_SEQUENCE_ID = 15225
    PBSE_SVR_SCHED_JSF_INCOMPAT = 15226
    PBSE_NODE_BUSY = 15227
    PBSE_DEFAULT_PARTITION = 15228
    PBSE_HISTDEPEND = 15229
    PBSE_SCHEDCONNECTED = 15230
    PBSE_NOTARRAY_ATTR = 15231


class LogEventTypes(Enum):
    PBSEVENT_ERROR = 0x0001
    PBSEVENT_SYSTEM = 0x0002
    PBSEVENT_ADMIN = 0x0004
    PBSEVENT_JOB = 0x0008
    PBSEVENT_JOB_USAGE = 0x0010
    PBSEVENT_SECURITY = 0x0020
    PBSEVENT_SCHED = 0x0040
    PBSEVENT_DEBUG = 0x0080
    PBSEVENT_DEBUG2 = 0x0100
    PBSEVENT_RESV = 0x0200
    PBSEVENT_DEBUG3 = 0x0400
    PBSEVENT_DEBUG4 = 0x0800
    PBSEVENT_DEBUGPRT = 0x1000
    PBSEVENT_FORCE = 0x8000
