# Copyright (C) 2024, UChicago Argonne, LLC
# Licensed under the 3-clause BSD license.  See accompanying LICENSE.txt file
# in the top-level directory.

from PBS_Utils.pbs_util import get_now, get_now_day_str, datetime_to_str


def test_get_now_00():
    now = get_now()
    now2 = get_now()
    assert (now2 - now).total_seconds() < 1

    now = get_now(notz=True)
    now2 = get_now(notz=True)
    assert (now2 - now).total_seconds() < 1
    assert now.tzinfo is None
    assert now2.tzinfo is None

    now = get_now(notz=False)
    now2 = get_now(notz=False)
    assert (now2 - now).total_seconds() < 1
    assert now.tzinfo is not None
    assert now2.tzinfo is not None


def test_get_now_day_str_00():
    now = get_now_day_str()
    assert now is not None
    assert len(now) == 8


def test_datetime_to_str_00():
    now = get_now()
    result = datetime_to_str(now)
    assert result is not None
    assert len(result) == 26
